#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include "ctx.h"
#include "util.h"

bool ctx_init(ctx_t *ctx, char *homedir) {
  bzero(ctx, sizeof(ctx_t));

  if (NULL == homedir)
    return false;

  size_t home_len = strlen(homedir);
  ctx->dir_path   = malloc(home_len + 20);
  ctx->tmp_path   = malloc(home_len + 25);
  ctx->lock_path  = malloc(home_len + 25);

  ctx->home_path = strdup(homedir);
  join(ctx->dir_path, homedir, ".local/share/mc");
  join(ctx->lock_path, ctx->dir_path, "lock");
  join(ctx->tmp_path, ctx->dir_path, "tmp");

  return true;
}

void ctx_free(ctx_t *ctx) {
  free(ctx->dir_path);
  free(ctx->tmp_path);
  free(ctx->lock_path);
  free(ctx->home_path);
  bzero(ctx, sizeof(ctx_t));
}
